//
// Institut fr Betriebssysteme und Rechnerverbund
// bungen zur Vorlesung "Verteilte Systeme", WS 02/03 
// http://www.ibr.cs.tu-bs.de/lehre/ws0203/vs/
// 
// Dozent: Prof. Dr. Stefan Fischer <fischer@ibr.cs.tu-bs.de>
// bungsleiter: Frank Strau <strauss@ibr.cs.tu-bs.de>
//
// Aufgabe 5.1 - CORBA mittels Java
//
// Der Server knnte so aussehen...
//
//   Usage: javac DocServer.java
//          tnameserv -ORBInitialPort 9000
//          java DocServer -ORBInitialHost hansa -ORBInitialPort 9000
//

import java.io.InputStreamReader;
import java.io.FileReader;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.StringTokenizer;

import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;

import DocService.*;
import DocService.DocPackage.*;


public class DocServer 
{
    public static void main(String args[])
    {
        try {
            
            // Create and initialize the ORB
            ORB orb = ORB.init(args, null);
            
            // Create the servant and register it with the ORB
            DocServant servant = new DocServant();
            orb.connect(servant);
            
            // Get the root naming context
            org.omg.CORBA.Object nsobj =
                orb.resolve_initial_references("NameService");
            NamingContext context = NamingContextHelper.narrow(nsobj);
            
            // Bind the object reference in naming
            NameComponent component = new NameComponent("DocServer", "");
            NameComponent path[] = {component};
            context.rebind(path, servant);
      
            // Wait for invocations from clients
            java.lang.Object sync = new java.lang.Object();
            synchronized (sync) {
                sync.wait();
            }
            
        } catch(Exception e) {
            System.err.println("ERROR: " + e);
            e.printStackTrace(System.out);
        }  
    }
}


class DocServant extends _DocImplBase
{
    public String getURL(String uri)
        throws NoSuchDocument
    {
        System.out.println("Received Method Incovation: getURL(" + uri + ")");
        
        char buf[] = new char[32768];
        String response = "";
        try {
            StringTokenizer st = new StringTokenizer(uri, "/");
            String basename = null;
            int rc;
            while (st.hasMoreTokens()) { basename = st.nextToken(); }
            FileReader file = new FileReader(basename);
            do {
                rc = file.read(buf);
                if (rc > 0) {
                    response += new String(buf);
                }
            } while (rc >= 0);
            System.out.println("Returning response");
            return response;
        } catch (IOException e) {
            System.out.println("Throwing Exception: NoSuchDocument");
            throw new NoSuchDocument();
        }
    }
}
