//
// Institut fr Betriebssysteme und Rechnerverbund
// bungen zur Vorlesung "Verteilte Systeme", WS 02/03 
// http://www.ibr.cs.tu-bs.de/lehre/ws0203/vs/
// 
// Dozent: Prof. Dr. Stefan Fischer <fischer@ibr.cs.tu-bs.de>
// bungsleiter: Frank Strau <strauss@ibr.cs.tu-bs.de>
//
// Aufgabe 4.1 - TCP Client/Server mittels Java
//
// Der Client knnte so aussehen...
//
//   Usage: javac TCPClient.java && java TCPClient hostname test.html
//

import java.lang.System;
import java.net.Socket;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.PrintWriter;

public class TCPClient {

    public static void main (String args[]) {
        try {
            Socket socket = new Socket(args[0], 8000);

            BufferedReader in = 
                new BufferedReader(
                new InputStreamReader(socket.getInputStream()));
            PrintWriter out = 
                new PrintWriter(socket.getOutputStream());

            String request = "GET " + args[1];
            out.println(request);
            out.flush();
            System.out.println("Sent Request: " + request);

            System.out.print("Received Response: ");
            String line;
            while ((line = in.readLine()) != null) {
                System.out.println(line);
            }

            socket.close();
        } catch (Exception e) {
            System.out.println(e);
        }
    }
}
